package sun.tracing.dtrace;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import sun.tracing.ProbeSkeleton;

class DTraceProbe extends ProbeSkeleton
{
    private Object proxy;
    private Method declared_method;
    private Method implementing_method;
    
    DTraceProbe(Object proxy, Method declared_method) {
        super(declared_method.getParameterTypes());
        this.proxy = proxy;
        this.declared_method = declared_method;
        try {
            this.implementing_method = proxy.getClass().getMethod(declared_method.getName(), declared_method.getParameterTypes());
        }
        catch (NoSuchMethodException ex) {
            throw new RuntimeException("Internal error, wrong proxy class");
        }
    }
    
    public boolean isEnabled() {
        return JVM.isEnabled(this.implementing_method);
    }
    
    public void uncheckedTrigger(Object[] args) {
        try {
            this.implementing_method.invoke(this.proxy, args);
        }
        catch (IllegalAccessException ex) {
            assert false;
        }
        catch (InvocationTargetException ex2) {
            assert false;
        }
    }
    
    String getProbeName() {
        return DTraceProvider.getProbeName(this.declared_method);
    }
    
    String getFunctionName() {
        return DTraceProvider.getFunctionName(this.declared_method);
    }
    
    Method getMethod() {
        return this.implementing_method;
    }
    
    Class<?>[] getParameterTypes() {
        return this.parameters;
    }
}
